Class: Sketchup::ComponentInstance

Inherits:
Drawingelement show all

Overview

The ComponentInstance class is used to represent component instances of a component definition or components that have been dragged from the Component Browser and placed (thus, instanced) within the Model. Therefore, the ComponentInstance class contains a reference to a corresponding ComponentDefinition object and a Transformation object (which contains the location of the component in the Drawing Window).

Version:

  • SketchUp 6.0

Instance Method Summary # collapse

Methods inherited from Drawingelement

#bounds, #casts_shadows=, #casts_shadows?, #erase!, #hidden=, #hidden?, #layer, #layer=, #material, #material=, #receives_shadows=, #receives_shadows?, #visible=, #visible?

Methods inherited from Entity

#attribute_dictionaries, #attribute_dictionary, #delete_attribute, #deleted?, #entityID, #get_attribute, #inspect, #model, #parent, #persistent_id, #set_attribute, #to_s, #typename, #valid?

Instance Method Details

#add_observer(observer) ⇒ Object

The add_observer method is used to add an observer to the current object.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)
status = componentinstance.add_observer observer

Returns true if successful, false if unsuccessful.

Parameters:

  • observer

    An observer.

Returns:

  • true if successful, false if unsuccessful.

Version:

  • SketchUp 6.0

#definitionObject

The definition method is used to retrieve the component definition for this component instance.

Examples:

# First create an instance for us to look at.
entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)

# You can get an instance's definition with this method.
definition = componentinstance.definition

Returns:

  • componentdefinition - a ComponentDefinition object if successful

Version:

  • SketchUp 6.0

#definition=(definition) ⇒ Object

The definition= method is used to set the component definition for this component.

This method causes the instance to use a different definition, but it will use the same transformation to position it in the Model.

Examples:

# Assumes that the active model contains two different components.
instance1 = Sketchup.active_model.entities[0]
instance2 = Sketchup.active_model.entities[1]

# Grab handles to our two definitions.
definition1 = instance1.definition
definition2 = instance2.definition

# Replace 2nd instance with the 1st definition.
instance2.definition = definition1

Returns componentdefinition - the ComponentDefinition object that was set if successful, false if unsuccessful

Parameters:

  • definition

    A ComponentDefinition object to set.

Returns:

  • componentdefinition - the ComponentDefinition object that was set if successful, false if unsuccessful

Version:

  • SketchUp 6.0

#equals?(instance) ⇒ Object

The equals? method is used to determine if a component instance is geometrically equivalent to another instance.

Examples:

entities = Sketchup.active_model.entities
instance1 = entities[0]
instance2 = entities[1]
status = instance1.equals?(instance2)

Returns status - true if the instances are geometrically equivalent. Otherwise false.

Parameters:

  • instance

    The instance to compare this instance with.

Returns:

  • status - true if the instances are geometrically equivalent. Otherwise false.

Returns:

  • (Boolean)

Version:

  • SketchUp 8.0

#explodeObject

The explode method is used to explode the component instance into separate entities.

Examples:

# Assuming 'instance' is a ComponentInstance object
array = instance.explode
if array
  UI.messagebox "Exploded the component instance"
else
  UI.messagebox "Failure"
end

Returns:

  • An array of entity objects if successful, false if unsuccessful

Version:

  • SketchUp 6.0

#glued_toObject

The glued_to method is used to retrieve the entity that this instance is glued to.

Returns nil if it is not glued to anything.

Examples:

point = Geom::Point3d.new 10,20,30
transform = Geom::Transformation.new point
model = Sketchup.active_model
entities = model.active_entities
path = Sketchup.find_support_file "Bed.skp",
  "Components/Components Sampler/"
definitions = model.definitions
componentdefinition = definitions.load path
instance = entities.add_instance componentdefinition, transform
status = instance.glued_to

Returns:

  • entity - the Entity object that the instance is glued to (if successful)

Version:

  • SketchUp 6.0

#glued_to=(face) ⇒ Object

The glued_to= method glues this instance to a face.

This method will raise an exception if the instance cannot be glued to the given face. Instances cannot be glued if the definition of the instance doesn't support gluing or if the alignment is wrong.

Examples:

depth = 100
width = 100
path=Sketchup.find_support_file "Bed.skp",
  "Components/Components Sampler/"
model = Sketchup.active_model
entities = model.active_entities
pts = []
pts[0] = [0, 0, 0]
pts[1] = [width, 0, 0]
pts[2] = [width, depth, 0]
pts[3] = [0, depth, 0]
# Add the face to the entities in the model
face = entities.add_face pts
point = Geom::Point3d.new 10,10,0
transform = Geom::Transformation.new point
definitions = model.definitions
componentdefinition = definitions.load path
instance = entities.add_instance componentdefinition, transform
begin
  status = instance.glued_to = face
rescue
  UI.messagebox $!.message
end
if (status)
  UI.messagebox status.to_s
else
  UI.messagebox "Failure"
end

Returns face - the Face object where the component is glued if successful

Parameters:

Returns:

  • face - the Face object where the component is glued if successful

Version:

  • SketchUp 6.0

#guidObject

The guid method is used to get the base 64 encoded unique id for this SketchUp object.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)
guid = componentinstance.guid

Returns:

  • guid - a unique 22 character string

Version:

  • SketchUp 2014

#intersect(instance) ⇒ Object

The intersect method is used to compute the boolean intersection of two instances representing manifold solid volumes (this - arg). If the specified objects (this and arg) do not represent manifold volumes, this method fails.

Examples:

entities = Sketchup.active_model.entities
instance1 = entities[0]
instance2 = entities[1]
result = instance1.intersect(instance2)

Returns result - The resultant group if the two objects (this and arg) represent manifold solids and the operation succeeds otherwise nil is returned.

Parameters:

  • instance

    The instance to intersect this instance with.

Returns:

  • result - The resultant group if the two objects (this and arg) represent manifold solids and the operation succeeds otherwise nil is returned.

Version:

  • SketchUp 8.0

#locked=(lock) ⇒ Object

The locked= method is used to lock a component instance.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)
status = componentinstance.locked = true

Returns status - true if the component instance is locked. False if the instance is not locked.

Parameters:

  • lock (Boolean)

Returns:

  • status - true if the component instance is locked. False if the instance is not locked.

Version:

  • SketchUp 6.0

#locked?Object

The locked? method is used to determine if a component instance is locked.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)
status = componentinstance.locked?

Returns:

  • status - true if the component instance is locked. False if the instance is not locked.

  • (Boolean)

Version:

  • SketchUp 6.0

#make_uniqueObject

The make_unique method is used to create a component definition for this instance that is not used by any other instances.

Examples:

point = Geom::Point3d.new 10,20,30
transform = Geom::Transformation.new point
model = Sketchup.active_model
entities = model.active_entities

path = Sketchup.find_support_file "Bed.skp",
  "Components/Components Sampler/"
definitions = model.definitions
componentdefinition = definitions.load path
instance = entities.add_instance componentdefinition, transform
# Returns unique component instance
status = instance.make_unique

Returns:

  • status - true if successful, false if unsuccessful

Version:

  • SketchUp 6.0

#manifold?Object

The manifold? method is used to determine if an instance is manifold.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)
status = componentinstance.manifold?

Returns:

  • status - true if the instance is manifold. false if the instance is not manifold.

  • (Boolean)

Version:

  • SketchUp 8.0

#move!(transform) ⇒ Object

The move! method is the same as the transform! method, except that it does not record the move as an undo operation.

This method is useful for moving entities inside of an animation or page transition.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)
new_transformation = Geom::Transformation.new([100,0,0])
componentinstance.move! new_transformation

Returns status - true if successful, false if unsuccessful

Parameters:

  • transform

    The transform object to apply to the component instance.

Returns:

  • status - true if successful, false if unsuccessful

Version:

  • SketchUp 6.0

#nameObject

The name method is used to get the name of this instance.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)
name = componentinstance.name

Returns:

  • name - the string name of the ComponentInstance

Version:

  • SketchUp 6.0

#name=(name) ⇒ Object

The name method is used to set the name of this instance.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)
componentinstance.name = "Sang"

Returns instance - the newly named ComponentInstance

Parameters:

  • name

    name - the string name to set

Returns:

  • instance - the newly named ComponentInstance

Version:

  • SketchUp 6.0

#outer_shell(instance) ⇒ Object

The outer_shell method is used to compute the outer shell of the two instances representing manifold solid volumes (this || arg). If the specified objects (this and arg) do not represent manifold volumes, this method fails.

Examples:

entities = Sketchup.active_model.entities
instance1 = entities[0]
instance2 = entities[1]
result = instance1.outer_shell(instance2)

Returns result - The resultant group if the two objects (this and arg) represent manifold solids and the operation succeeds otherwise nil is returned.

Parameters:

  • instance

    The instance to outer shell this instance with.

Returns:

  • result - The resultant group if the two objects (this and arg) represent manifold solids and the operation succeeds otherwise nil is returned.

Version:

  • SketchUp 8.0

#remove_observer(observer) ⇒ Object

The remove_observer method is used to remove an observer from the current object.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)
status = componentinstance.remove_observer observer

Returns true if successful, false if unsuccessful.

Parameters:

  • observer

    An observer.

Returns:

  • true if successful, false if unsuccessful.

Version:

  • SketchUp 6.0

#show_differences(instance, verbose) ⇒ Object

The show_differences method is used to determine if a component instance is geometrically equivalent to another instance and in addition move the non- matching and matching geometry to new layers.

This method will move both instances to Layer0. Geometry that is the same in both components will be moved to a new layer named def_name + “_same”. Geometry that is not the same will be moved to a layer named def_name + “_diff”.

If verbose is true, a list of all the geometry that is different from one component to the other is displayed texturally in the Ruby Console.

Examples:

entities = Sketchup.active_model.entities
instance1 = entities[0]
instance2 = entities[1]
status = instance1.show_differences(instance2, true)

Returns status - true if the instances are geometrically equivalent, otherwise false.

Parameters:

  • instance

    The instance to be compared with.

  • verbose

    A boolean flag indicating whether to display a textural report of the found differences to the Ruby console.

Returns:

  • status - true if the instances are geometrically equivalent, otherwise false.

Version:

  • SketchUp 8.0

#split(instance) ⇒ Object

The split method is used to compute the boolean split (map overlay)of the two instances representing manifold solid volumes (this - arg). If the specified objects (this and arg) do not represent manifold volumes, this method fails.

Examples:

entities = Sketchup.active_model.entities
instance1 = entities[0]
instance2 = entities[1]
result = instance1.split(instance2)

Result - A vector (array) of the three resultant groups if the two objects (this and arg) represent manifold solids and the operation succeeds otherwise Qnil is returned. The 3 groups are as follows: The intersection of volume 1 & volume 2, the difference of volume 1 minus volume 2, and the reverse difference of volume 2 minus volume 1.

Parameters:

  • instance

    The instance to split this instance with.

Returns:

  • result - A vector (array) of the three resultant groups if the two objects (this and arg) represent manifold solids and the operation succeeds otherwise Qnil is returned. The 3 groups are as follows: The intersection of volume 1 & volume 2, the difference of volume 1 minus volume 2, and the reverse difference of volume 2 minus volume 1.

Version:

  • SketchUp 8.0

#subtract(instance) ⇒ Object

The subtract method is used to compute the boolean difference of the two instances representing manifold solid volumes (this - arg). If the specified objects (this and arg) do not represent manifold volumes, this method fails.

Examples:

entities = Sketchup.active_model.entities
instance1 = entities[0]
instance2 = entities[1]
result = instance1.subtract(instance2)

Returns result - The resultant group if the two objects (this and arg) represent manifold solids and the operation succeeds otherwise nil is returned.

Parameters:

  • instance

    The instance to subtract this instance from.

Returns:

  • result - The resultant group if the two objects (this and arg) represent manifold solids and the operation succeeds otherwise nil is returned.

Version:

  • SketchUp 8.0

#transform!(transform) ⇒ Boolean

Apply a Geom::Transformation to a component instance.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0, 0, 0])
componentinstance = entities.add_instance(definition, transformation)
new_transformation = Geom::Transformation.new([100, 0, 0])
componentinstance.transform! new_transformation

Parameters:

  • transform (Geom::Transformation)

    The transformation object to apply to the component instance.

Returns:

  • (Boolean)

Version:

  • SketchUp 6.0

#transformationObject

The transformation method is used to retrieve the transformation of this instance.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)
t = componentinstance.transformation

Returns:

  • transformation - the Transformation object if successful

Version:

  • SketchUp 6.0

#transformation=(transformation) ⇒ Object

The transformation= method is used to set the transformation on this instance.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)
new_transformation = Geom::Transformation.new([100,0,0])
componentinstance.transformation = new_transformation

Returns instance - the transformed ComponentInstance

Parameters:

  • transformation

    A Transformation object to apply.

Returns:

  • instance - the transformed ComponentInstance

Version:

  • SketchUp 6.0

#trim(instance) ⇒ Object

The trim method is used to compute the (non-destructive) boolean difference of the two instances representing manifold solid volumes (this - arg). If the specified objects (this and arg) do not represent manifold volumes, this method fails.

Examples:

entities = Sketchup.active_model.entities
instance1 = entities[0]
instance2 = entities[1]
result = instance1.trim(instance2)

Returns result - The resultant group if the two objects (this and arg) represent manifold solids and the operation succeeds otherwise nil is returned.

Parameters:

  • instance

    The instance to trim this instance against.

Returns:

  • result - The resultant group if the two objects (this and arg) represent manifold solids and the operation succeeds otherwise nil is returned.

Version:

  • SketchUp 8.0

#union(instance) ⇒ Object

The union method is used to compute the boolean union of the two instances representing manifold solid volumes (this | arg). If the specified objects (this and arg) do not represent manifold volumes, this method fails.

Examples:

entities = Sketchup.active_model.entities
instance1 = entities[0]
instance2 = entities[1]
result = instance1.union(instance2)

Returns result - The resultant group if the two objects (this and arg) represent manifold solids and the operation succeeds otherwise nil is returned.

Parameters:

  • instance

    The instance to union this instance with.

Returns:

  • result - The resultant group if the two objects (this and arg) represent manifold solids and the operation succeeds otherwise nil is returned.

Version:

  • SketchUp 8.0

#volumeObject

The volume method is used to compute the volume of this instance if and only if this instance is manifold.

Examples:

entities = Sketchup.active_model.entities
definition = Sketchup.active_model.definitions[0]
transformation = Geom::Transformation.new([0,0,0])
componentinstance = entities.add_instance(definition, transformation)
volume = componentinstance.volume

Returns:

  • volume - If the instance represents a manifold volume, volume will be a positive value. If volume is negative, the instance is not manifold.

Version:

  • SketchUp 8.0